import { BaseEntity, CreateDateColumn, UpdateDateColumn, ValueTransformer } from 'typeorm';
import * as moment from 'moment';

class CustomTimeTransformer implements ValueTransformer {
  to(): any {
    // return moment().utcOffset(0).format('YYYY-MM-DD HH:mm:ss.SSS');
    return moment().utcOffset(0).toDate();
  }

  from(value: any): any {
    return moment(value).format('YYYY-MM-DD HH:mm:ss.SSS');
  }
}

export abstract class BaseModel extends BaseEntity {
  @CreateDateColumn({
    type: 'timestamp',
    transformer: new CustomTimeTransformer(),
  })
  created_at: string;

  @UpdateDateColumn({
    type: 'timestamp',
    transformer: new CustomTimeTransformer(),
  })
  updated_at: string;

  @UpdateDateColumn({
    type: 'timestamp',
    transformer: new CustomTimeTransformer(),
  })
  timestamp: string;
}
